<!DOCTYPE composition PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
        "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<ui:composition xmlns:s="http://jboss.org/schema/seam/taglib" xmlns:rich="http://richfaces.org/rich"
                xmlns:h="http://java.sun.com/jsf/html" xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns:f="http://java.sun.com/jsf/core"
                xmlns:g="http://www.ihe.net/gazelle" xmlns:a4j="http://richfaces.org/a4j"
                xmlns="http://www.w3.org/1999/xhtml" template="//layout/template.xhtml">
    <ui:param name="pageName" value="#{messages['net.ihe.gazelle.schematronvalidator.ManageSchematrons']}"/>
    <ui:param name="pageNameUrl" value="schematrons/manageSchematrons.seam"/>
    <ui:param name="pageNameTitle" value="#{messages['net.ihe.gazelle.schematronvalidator.ManageSchematrons']}"/>
    <ui:define name="body">
        <h1>#{messages['net.ihe.gazelle.schematronvalidator.ManageSchematrons']}</h1>
        <h:form id="globalForm" styleClass="form-horizontal">
            <s:div id="globalDiv">
                <ui:decorate template="/layout/panels/_panel_filter_criteria.xhtml">
                    <div class="row">
                        <div class="col-lg-6">
                            <ui:include src="/filter/filterDate.xhtml">
                                <ui:param name="filter" value="#{schematronManagerBean.filter}"/>
                                <ui:param name="filterId" value="lastChanged"/>
                                <ui:param name="filterName" value="#{messages['net.ihe.gazelle.schematronvalidator.LastChanged']}"/>
                                <ui:param name="filterForm" value="globalForm"/>
                            </ui:include>
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-lg-6">
                            <ui:include src="/filter/filter.xhtml">
                                <ui:param name="filter" value="#{schematronManagerBean.filter}"/>
                                <ui:param name="filterId" value="available"/>
                                <ui:param name="filterName" value="#{messages['net.ihe.gazelle.schematronvalidator.Available']}"/>
                                <ui:param name="filterForm" value="globalForm"/>
                            </ui:include>
                        </div>
                        <div class="col-lg-6">
                            <ui:include src="/filter/filter.xhtml">
                                <ui:param name="filter" value="#{schematronManagerBean.filter}"/>
                                <ui:param name="filterId" value="objectType"/>
                                <ui:param name="filterName" value="#{messages['net.ihe.gazelle.schematronvalidator.ObjectType']}"/>
                                <ui:param name="filterForm" value="globalForm"/>
                            </ui:include>
                        </div>
                    </div>
                    <ui:define name="filter_buttons">
                        <a4j:commandLink actionListener="#{schematronManagerBean.filter.clear()}"
                                         title="#{messages['net.ihe.gazelle.maven.Reset']}" type="submit"
                                         execute="@this" render="globalForm,AllSchematronsPanel">
                            <span class="fa fa-times-circle"/>
                        </a4j:commandLink>
                    </ui:define>
                </ui:decorate>
                <s:div id="AllSchematronsPanel">
                    <ui:decorate template="/layout/panels/_panel_title_footer.xhtml">
                        <ui:define name="panel_title">#{messages['net.ihe.gazelle.schematronvalidator.Schematrons']}
                        </ui:define>

                        <rich:dataTable id="schematronListTable"
                                        value="#{schematronManagerBean.getAllSchematrons()}" var="currentSchematron"
                                        rows="#{dataScrollerMemory.numberOfResultsPerPage}">
                            <g:column id="IdColumn" sortBy="#{'id'}" sortOrder="descending" filterBy="#{'id'}">
                                <ui:define name="header">#{messages['net.ihe.gazelle.schematronvalidator.ID']}</ui:define>
                                <h:outputText value="#{currentSchematron.id}"/>
                            </g:column>
                            <g:column id="LabelColumn" sortBy="#{'name'}"
                                      filterBy="#{'name'}">
                                <ui:define name="header">#{messages['net.ihe.gazelle.schematronvalidator.Name']}
                                </ui:define>
                                <h:outputText value="#{currentSchematron.name}"/>
                            </g:column>
                            <g:column id="VersionColumn" sortBy="#{'version'}"
                                      filterBy="#{'version'}">
                                <ui:define name="header">#{messages['net.ihe.gazelle.schematronvalidator.Version']}
                                </ui:define>
                                <h:outputText value="#{currentSchematron.version}"/>
                            </g:column>
                            <g:column id="LastChangedColumn" sortBy="#{'lastChanged'}">
                                <ui:define name="header">#{messages['net.ihe.gazelle.schematronvalidator.LastChanged']}
                                </ui:define>
                                <h:outputText value="#{currentSchematron.lastChanged}"/>
                            </g:column>
                            <g:column id="PathColumn" width="150px" sortBy="#{'path'}"
                                      filterBy="#{'path'}">
                                <ui:define name="header">#{messages['net.ihe.gazelle.schematronvalidator.Path']}
                                </ui:define>
                                <h:outputText value="#{currentSchematron.path}"/>
                            </g:column>
                            <g:column id="ObjectTypeColumn">
                                <ui:define name="header">#{messages['net.ihe.gazelle.schematronvalidator.ObjectType']}
                                </ui:define>
                                <h:outputText value="#{currentSchematron.objectType.name}"/>
                            </g:column>
                            <g:column id="AvailableColumn" sortBy="#{'available'}">
                                <ui:define name="header">#{messages['net.ihe.gazelle.schematronvalidator.Available']}
                                </ui:define>
                                <s:span rendered="#{currentSchematron.available}">
                                    <h:outputText value="#{messages['net.ihe.gazelle.True']}"/>
                                </s:span>
                                <s:span rendered="#{!currentSchematron.available}">
                                    <h:outputText value="#{messages['net.ihe.gazelle.False']}"/>
                                </s:span>
                            </g:column>
                            <g:column id="timestampColumn">
                                <ui:define name="header">#{messages['net.ihe.gazelle.schematronvalidator.LastCompilationTimestamp']}
                                </ui:define>
                                <s:span>
                                    <h:outputText value="#{schematronManagerBean.getCompilationTimestamp(currentSchematron)}"/>
                                </s:span>
                            </g:column>
                            <g:column id="actionColumn">
                                <ui:define name="header">#{messages['net.ihe.gazelle.schematronvalidator.Action']}
                                    <h:panelGroup rendered="#{s:hasRole('admin_role')}">
                                        <a4j:commandLink
                                                title="#{messages['net.ihe.gazelle.maven.CompileAll']}"
                                                action="#{schematronManagerBean.compileAllSchematrons()}"
                                                render="globalDiv">
                                            <span class="gzl-icon-play"></span>
                                        </a4j:commandLink>
                                    </h:panelGroup>
                                </ui:define>
                                <div class="gzl-never-wrap">
                                    <a4j:commandLink
                                            action="#{schematronManagerBean.displaySchematron(currentSchematron)}"
                                            title="#{messages['net.ihe.gazelle.schematronvalidator.View']}">
                                        <span class="gzl-icon-search"></span>
                                    </a4j:commandLink>
                                    <h:panelGroup rendered="#{s:hasRole('admin_role')}">
                                        <a4j:commandLink
                                                action="#{schematronManagerBean.editSchematron(currentSchematron)}"
                                                title="#{messages['net.ihe.gazelle.schematronvalidator.Edit']}">
                                            <span class="gzl-icon-pencil"></span>
                                        </a4j:commandLink>

                                        <a4j:commandLink
                                                action="#{schematronManagerBean.copySchematron(currentSchematron)}"
                                                render="AllSchematronsPanel"
                                                title="#{messages['net.ihe.gazelle.schematronvalidator.Duplicate']}">
                                            <span class="gzl-icon-files-o"></span>
                                        </a4j:commandLink>

                                        <a4j:commandLink id="deleteActionButton"
                                                         title="#{messages['net.ihe.gazelle.schematronvalidator.Delete']}"
                                                         render="deleteTextDiv"
                                                         action="#{schematronManagerBean.setSelectedSchematron(currentSchematron)}"
                                                         oncomplete="jq162('#deleteSchematronPopup').modal('show');">
                                            <span class="gzl-icon-trash-o"></span>
                                        </a4j:commandLink>

                                        <a4j:commandLink
                                                title="#{messages['net.ihe.gazelle.schematronvalidator.Compile']}"
                                                action="#{schematronManagerBean.compileSchematronFromGUI(currentSchematron)}"
                                                render="globalDiv" rendered="#{currentSchematron.path.length() &gt; 0 }">
                                            <span class="gzl-icon-play"></span>
                                        </a4j:commandLink>

                                        <a4j:commandLink
                                                title="#{messages['net.ihe.gazelle.maven.ReloadXSD']}"
                                                action="#{schematronManagerBean.reloadXSD(currentSchematron)}"
                                                render="globalDiv" rendered="#{currentSchematron.xsdPath.length() &gt; 0 }">
                                            <span class="gzl-icon-refresh"></span>
                                        </a4j:commandLink>

                                    </h:panelGroup>
                                </div>
                            </g:column>


                            <f:facet name="footer">
                                <ui:include src="/util/datatableFooter.xhtml">
                                    <ui:param name="dataScrollerId" value="ds"/>
                                    <ui:param name="dataTableId" value="schematronListTable"/>
                                </ui:include>
                            </f:facet>
                        </rich:dataTable>
                        <ui:define name="panel_footer">
                            <a4j:commandButton id="createNewSchematronButton" styleClass="gzl-btn-green"
                                               value="#{messages['net.ihe.gazelle.schematronvalidator.NewSchematron']}"
                                               action="/schematrons/createSchematron.xhtml"
                                               rendered="#{s:hasRole('admin_role')}"
                                               render="globalDiv, editSchematronPanel"/>
                            <a4j:commandButton id="updateSchematrons" styleClass="gzl-btn-blue"
                                               value="#{messages['net.ihe.gazelle.schematronvalidator.UpdateSchematronsVersion']}"
                                               actionListener="#{schematronManagerBean.updateSchematronsVersion()}"
                                               rendered="#{s:hasRole('admin_role')}" render="globalDiv"/>
                        </ui:define>
                    </ui:decorate>
                </s:div>
            </s:div>

            <ui:decorate template="/layout/popup/_popup_title_footer.xhtml">
                <ui:param name="popup_id" value="deleteSchematronPopup"/>
                <ui:param name="styleClass" value="modal-sm"/>
                <ui:param name="headerStyleClass" value="gzl-text-red"/>
                <ui:define name="popup_title">
                    <span class="fa fa-exclamation-triangle"></span>
                    #{messages['net.ihe.gazelle.schematronvalidator.DeleteSchematron']}
                </ui:define>
                <ui:param name="bodyStyleClass" value="bg-warning"/>
                <s:div id="deleteTextDiv">
                    <h:outputText
                            value="#{messages['net.ihe.gazelle.maven.AreYouSureToDeleteTheSchematronWithTheName']} #{schematronManagerBean.selectedSchematron.name} ?"/>
                </s:div>
                <ui:define name="popup_footer">
                    <a4j:commandButton value="#{messages['net.ihe.gazelle.schematronvalidator.Yes']}"
                                       title="#{messages['net.ihe.gazelle.schematronvalidator.Delete']} #{schematronManagerBean.selectedSchematron.id}"
                                       action="#{schematronManagerBean.deleteSelectedSchematron()}"
                                       oncomplete="jq162('#deleteSchematronPopup').modal('hide');"
                                       render="globalDiv"
                                       styleClass="gzl-btn-red"/>
                    <a4j:commandButton value="#{messages['net.ihe.gazelle.schematronvalidator.No']}"
                                       styleClass="gzl-btn"
                                       oncomplete="jq162('#deleteSchematronPopup').modal('hide');"/>
                </ui:define>
            </ui:decorate>

        </h:form>
    </ui:define>
</ui:composition>
